/* mpTree 0.1.2
 * -----------[ http://mptree.netpedia.net
 *
 *   Use this software at your own risk!
 *    This software falls under the GPL.
 *   Read COPYING for further informations.
 */

#include "mptree.h"

#include "icons/save.xpm"
#include "icons/open.xpm"
#include "icons/new.xpm"

#include "icons/arrow_down1.xpm"
#include "icons/arrow_up1.xpm"

GtkWidget *newbtn, *openbtn, *savebtn, *upbtn, *downbtn, *deletebtn;

void create__toolbar()
{
    GtkWidget *toolbar, *new_icon, *save_icon, *open_icon, *a_up, *a_down;
    GdkPixmap *new_pixmap, *save_pixmap, *open_pixmap, *aup_pix, *adown_pix;
    GdkBitmap *bitmap;
    GtkStyle *style;

    toolbar = gtk_toolbar_new(GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_ICONS);

    style=gtk_widget_get_style(toolbar);
    new_pixmap = gdk_pixmap_create_from_xpm_d((mainwin)->window, &bitmap, &style->bg[GTK_STATE_NORMAL], (gchar **) new_icon_xpm);
    new_icon = gtk_pixmap_new(new_pixmap, bitmap);
    save_pixmap = gdk_pixmap_create_from_xpm_d((mainwin)->window, &bitmap, &style->bg[GTK_STATE_NORMAL], (gchar **) save_icon_xpm);
    save_icon = gtk_pixmap_new(save_pixmap, bitmap);
    open_pixmap = gdk_pixmap_create_from_xpm_d((mainwin)->window, &bitmap, &style->bg[GTK_STATE_NORMAL], (gchar **) open_icon_xpm);
    open_icon = gtk_pixmap_new(open_pixmap, bitmap);
    aup_pix = gdk_pixmap_create_from_xpm_d((mainwin)->window, &bitmap, &style->bg[GTK_STATE_NORMAL], (gchar **) arrow_up1_xpm);
    a_up = gtk_pixmap_new(aup_pix, bitmap);
    adown_pix = gdk_pixmap_create_from_xpm_d((mainwin)->window, &bitmap, &style->bg[GTK_STATE_NORMAL], (gchar **) arrow_down1_xpm);
    a_down = gtk_pixmap_new(adown_pix, bitmap);

    newbtn=gtk_toolbar_append_item(GTK_TOOLBAR(toolbar), NULL, "New database", "New", GTK_WIDGET(new_icon), new_database, NULL);
    openbtn=gtk_toolbar_append_item(GTK_TOOLBAR(toolbar), NULL, "Open database", "Open", GTK_WIDGET(open_icon), open_database_button, NULL);
    savebtn=gtk_toolbar_append_item(GTK_TOOLBAR(toolbar), NULL, "Save database", "Save", GTK_WIDGET(save_icon), save_database_button, NULL);
    gtk_toolbar_append_space(GTK_TOOLBAR(toolbar));
    upbtn=gtk_toolbar_append_item(GTK_TOOLBAR(toolbar), NULL, "Move Up", "up", GTK_WIDGET(a_up), sl_move_up, NULL);
    downbtn=gtk_toolbar_append_item(GTK_TOOLBAR(toolbar), NULL, "Move Down", "down", GTK_WIDGET(a_down), sl_move_down, NULL);
    
    gtk_toolbar_set_space_style(GTK_TOOLBAR(toolbar), GTK_TOOLBAR_SPACE_LINE);
    gtk_toolbar_set_space_size(GTK_TOOLBAR(toolbar), 20);
    gtk_toolbar_set_button_relief(GTK_TOOLBAR(toolbar), GTK_RELIEF_NONE);

    gtk_box_pack_start(GTK_BOX(box), toolbar, FALSE, FALSE, TRUE);
}

void file_open_ok_pressed(GtkWidget *w, GtkFileSelection *fs)
{
   loaddb(gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs)));
   gtk_widget_destroy(GTK_WIDGET(fs));
}

void open_database_button()
{
   GtkWidget *filedialog;

   filedialog = gtk_file_selection_new("Open: Select databasefile");
   gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (filedialog)->ok_button),
                        "clicked", (GtkSignalFunc) file_open_ok_pressed, filedialog );
   gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION
                                            (filedialog)->cancel_button),
                               "clicked", (GtkSignalFunc) gtk_widget_destroy,
                               GTK_OBJECT (filedialog));
   gtk_widget_show(filedialog);
}

void file_save_ok_pressed(GtkWidget *w, GtkFileSelection *fs)
{
   savedb(gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs)));
   gtk_widget_destroy(GTK_WIDGET(fs));
}

void save_database_button()
{
   GtkWidget *filedialog;

   filedialog = gtk_file_selection_new("Save database as");
   gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (filedialog)->ok_button),
                        "clicked", (GtkSignalFunc) file_save_ok_pressed, filedialog );
   gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION
                                            (filedialog)->cancel_button),
                               "clicked", (GtkSignalFunc) gtk_widget_destroy,
                               GTK_OBJECT (filedialog));
   gtk_widget_show(filedialog);
}

void disable_tb_items(int notebookpage)
{
   switch (notebookpage)
   {
      case 0: gtk_widget_set_sensitive(newbtn, TRUE);
      	      gtk_widget_set_sensitive(openbtn, TRUE);
	      gtk_widget_set_sensitive(savebtn, TRUE);
      	      gtk_widget_set_sensitive(upbtn, FALSE);
	      gtk_widget_set_sensitive(downbtn, FALSE);
	      break;
	      
      case 1: gtk_widget_set_sensitive(newbtn, TRUE);
      	      gtk_widget_set_sensitive(openbtn, TRUE);
	      gtk_widget_set_sensitive(savebtn, TRUE);
      	      gtk_widget_set_sensitive(upbtn, FALSE);
	      gtk_widget_set_sensitive(downbtn, FALSE);
	      break;

      case 2: gtk_widget_set_sensitive(newbtn, FALSE);
      	      gtk_widget_set_sensitive(openbtn, FALSE);
	      gtk_widget_set_sensitive(savebtn, FALSE);
      	      gtk_widget_set_sensitive(upbtn, TRUE);
	      gtk_widget_set_sensitive(downbtn, TRUE);
	      break;
   }	  
}
